Index: code/branches/physics/src/orxonox/objects/Scene.cc
===================================================================
--- code/branches/physics/src/orxonox/objects/Scene.cc	(revision 2303)
+++ code/branches/physics/src/orxonox/objects/Scene.cc	(revision 2304)
@@ -23,5 +23,5 @@
  *      Fabian 'x3n' Landau
  *   Co-authors:
- *      ...
+ *      Reto Grieder (physics)
  *
  */
Index: code/branches/physics/src/orxonox/objects/worldentities/MovableEntity.cc
===================================================================
--- code/branches/physics/src/orxonox/objects/worldentities/MovableEntity.cc	(revision 2303)
+++ code/branches/physics/src/orxonox/objects/worldentities/MovableEntity.cc	(revision 2304)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      Reto Grieder
  *   Co-authors:
  *      Martin Stypinski
Index: code/branches/physics/src/orxonox/objects/worldentities/MovableEntity.h
===================================================================
--- code/branches/physics/src/orxonox/objects/worldentities/MovableEntity.h	(revision 2303)
+++ code/branches/physics/src/orxonox/objects/worldentities/MovableEntity.h	(revision 2304)
@@ -21,7 +21,7 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      Reto Grieder
  *   Co-authors:
- *      ...
+ *      Martin Stypinski
  *
  */
Index: code/branches/physics/src/orxonox/objects/worldentities/StaticEntity.cc
===================================================================
--- code/branches/physics/src/orxonox/objects/worldentities/StaticEntity.cc	(revision 2303)
+++ code/branches/physics/src/orxonox/objects/worldentities/StaticEntity.cc	(revision 2304)
@@ -22,4 +22,5 @@
  *   Author:
  *      Fabian 'x3n' Landau
+ *      Reto Grieder (physics)
  *   Co-authors:
  *      ...
Index: code/branches/physics/src/orxonox/objects/worldentities/StaticEntity.h
===================================================================
--- code/branches/physics/src/orxonox/objects/worldentities/StaticEntity.h	(revision 2303)
+++ code/branches/physics/src/orxonox/objects/worldentities/StaticEntity.h	(revision 2304)
@@ -22,4 +22,5 @@
  *   Author:
  *      Fabian 'x3n' Landau
+ *      Reto Grieder
  *   Co-authors:
  *      ...
Index: code/branches/physics/src/orxonox/objects/worldentities/WorldEntity.cc
===================================================================
--- code/branches/physics/src/orxonox/objects/worldentities/WorldEntity.cc	(revision 2303)
+++ code/branches/physics/src/orxonox/objects/worldentities/WorldEntity.cc	(revision 2304)
@@ -22,4 +22,5 @@
  *   Author:
  *      Fabian 'x3n' Landau
+ *      Reto Grieder (physics)
  *   Co-authors:
  *      ...
@@ -394,40 +395,4 @@
     }
 
-    //void WorldEntity::setCollisionRadius(float radius)
-    //{
-    //    if (!checkPhysics())
-    //        return;
-
-    //    // destroy old one first
-    //    btCollisionShape* oldShape = this->physicalBody_->getCollisionShape();
-    //    if (oldShape)
-    //        delete oldShape;
-
-    //    //if (this->getName() == "blubb")
-    //    //{
-    //    //    btCompoundShape* cShape = new btCompoundShape();
-    //    //    cShape->setLocalScaling(btVector3(1,1,1));
-    //    //    btTransform offset(btQuaternion(0, 0, 0), btVector3(0, 0, 0));
-    //    //    offset.setBasis(btMatrix3x3(3, 0, 0, 0, 3, 0, 0, 0, 3));
-    //    //    btSphereShape* sphere = new btSphereShape(radius);
-    //    //    sphere->setLocalScaling(btVector3(1,1,3));
-    //    //    cShape->addChildShape(offset, sphere);
-    //    //    this->physicalBody_->setCollisionShape(cShape);
-    //    //}
-    //    //else
-    //    this->physicalBody_->setCollisionShape(new btSphereShape(btScalar(radius)));
-    //}
-
-    //float WorldEntity::getCollisionRadius() const
-    //{
-    //    if (checkPhysics())
-    //    {
-    //        btSphereShape* sphere = dynamic_cast<btSphereShape*>(this->physicalBody_->getCollisionShape());
-    //        if (sphere)
-    //            return (float)sphere->getRadius();
-    //    }
-    //    return 0.0f;
-    //}
-
     bool WorldEntity::checkPhysics() const
     {
Index: code/branches/physics/src/orxonox/objects/worldentities/WorldEntity.h
===================================================================
--- code/branches/physics/src/orxonox/objects/worldentities/WorldEntity.h	(revision 2303)
+++ code/branches/physics/src/orxonox/objects/worldentities/WorldEntity.h	(revision 2304)
@@ -22,4 +22,5 @@
  *   Author:
  *      Fabian 'x3n' Landau
+ *      Reto Grieder (physics)
  *   Co-authors:
  *      ...
Index: code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/CollisionShape.cc
===================================================================
--- code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/CollisionShape.cc	(revision 2303)
+++ code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/CollisionShape.cc	(revision 2304)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      Reto Grieder
  *   Co-authors:
  *      ...
Index: code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/CollisionShape.h
===================================================================
--- code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/CollisionShape.h	(revision 2303)
+++ code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/CollisionShape.h	(revision 2304)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      Reto Grieder
  *   Co-authors:
  *      ...
Index: code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/CompoundCollisionShape.cc
===================================================================
--- code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/CompoundCollisionShape.cc	(revision 2303)
+++ code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/CompoundCollisionShape.cc	(revision 2304)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      Reto Grieder
  *   Co-authors:
  *      ...
Index: code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/CompoundCollisionShape.h
===================================================================
--- code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/CompoundCollisionShape.h	(revision 2303)
+++ code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/CompoundCollisionShape.h	(revision 2304)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      Reto Grieder
  *   Co-authors:
  *      ...
Index: code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/SphereCollisionShape.cc
===================================================================
--- code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/SphereCollisionShape.cc	(revision 2303)
+++ code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/SphereCollisionShape.cc	(revision 2304)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      Reto Grieder
  *   Co-authors:
  *      ...
Index: code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/SphereCollisionShape.h
===================================================================
--- code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/SphereCollisionShape.h	(revision 2303)
+++ code/branches/physics/src/orxonox/objects/worldentities/collisionshapes/SphereCollisionShape.h	(revision 2304)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      Reto Grieder
  *   Co-authors:
  *      ...
Index: code/branches/physics/src/orxonox/tools/BulletConversions.h
===================================================================
--- code/branches/physics/src/orxonox/tools/BulletConversions.h	(revision 2303)
+++ code/branches/physics/src/orxonox/tools/BulletConversions.h	(revision 2304)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      Reto Grieder
  *   Co-authors:
  *      ...